POJ 2581 Exact Change Only(dp)

Language:
Exact Change Only
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 2584 Accepted: 883

Description

Boudreaux reached over and shook awake Thibodeaux, who had dozed off somewhere in New Mexico. "Where we at?" Thibodeaux groggily yawned. 

"Not in Vegas, I gua-ran-tee, but could you get my knapsack?" Boudreaux asked, gesturing to the worn, leather backpack in the back seat of their cherry red Ford Miata. 

"Why, is there a problem?" 

"Just hand me my knapsack, problem or not." 

Thibodeaux complied, glancing up as Boudreaux slowed the car to a stop in a line of vehicles approaching a toll booth. "$1.65 -- Exact change only," Thibodeaux read the yellow sign on the front of a small wooden building occupied by a lone toll booth operator. "I have to get $1.65 in exact change?" Thibodeaux asked, digging through the knapsack, "all I have are ten quarters, four dimes, and three pennies. I don't have any nickels . . ." 

"Just give me five of the quarters and the four dimes," Boudreaux replied, holding out his hand. 

"Oh yeah," Thibodeaux said, handing over the coins, "that does add up to $1.65. I wish there were an easy way to figure out if you have an exact monetary amount, given a set of coins." 

"Hmmm," Boudreaux shrugged, "sounds like a good programming problem." 

Input

Input to this problem will consist of a (non-empty) series of up to 100 data sets. Each data set will be formatted according to the following description, and there will be no blank lines separating data sets. 

A single data set has 1 component: 

Start line - A single line: 
A B C D E 

where: 
A: (0.01 <= A <= 5.00) is a decimal number (to two decimal places) of a monetary amount. 
B: (0 <= B <= 100) is an integer number of quarters (one quarter = $0.25). 
C: (0 <= C <= 100) is an integer number of dimes (one dime = $0.10). 
D: (0 <= D <= 100) is an integer number of nickels (one nickel = $0.05). 
E: (0 <= E <= 100) is an integer number of pennies (one penny = $0.01).

Output

For each data set, there will be exactly one line of output. If there exists one or more subsets of the given coins whose values add up to the given monetary amount exactly, the output will be a single line in the form: 

A B C D 

where A is the number of quarters, B is the number of dimes, C is the number of nickels, and D is the number of pennies, for the subset with the fewest number of coins. Otherwise, the output will be a single line with the statement: 
NO EXACT CHANGE 

Sample Input

0.45 2 1 1 4
0.75 3 7 1 75

Sample Output

NO EXACT CHANGE
3 0 0 0

Source




就是把钱放大100倍后看组合成all,种钱最少需要几张钱?

dp+记录路径,值得一提的是这个题也可以4个for循环过,但是还是感觉dp高大上一点吧


#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define N 1000

int num[5],dp[N],pre[N],all;
int op[5]={25,10,5,1};
int ans[N];

int main()
{
	int i,j;
	double x;
	while(~scanf("%lf",&x))
	{
		all=(int)(x*100);
		for(i=0;i<4;i++)
			scanf("%d",&num[i]);

		memset(dp,0,sizeof(dp));
		dp[0]=1;

		for(i=0;i<4;i++)
		{
			if(op[i]*num[i]>=all)
			{
				for(int v=op[i];v<=all;v++)
					if(dp[v-op[i]]&&(dp[v]==0||dp[v]>dp[v-op[i]]+1))
				{
					dp[v]=dp[v-op[i]]+1;
					pre[v]=v-op[i];
				}
			}
			else
			{
				int t=num[i];
				while(t--)
				{
					for(int v=all;v>=op[i];v--)
						 if(dp[v-op[i]]&&(dp[v]==0||dp[v]>dp[v-op[i]]+1))
						{
							dp[v]=dp[v-op[i]]+1;
							pre[v]=v-op[i];
						}
				}
			}
		}
		if(!dp[all])
		{
			printf("NO EXACT CHANGE\n");
			continue;
		}
		 memset(ans,0,sizeof(dp));
		 i=all;
		 while(i)
		 {
		 	ans[i-pre[i]]++;
		 	i=pre[i];
		 }
		 printf("%d %d %d %d\n",ans[25],ans[10],ans[5],ans[1]);
	}
	return 0;
}







  • 0
    点赞
  • 3
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值